Subject: Re: [PATCH 03/16] dma-debug: add hash functions for dma_debug_entries

From: Andrew Morton <[email-masked]>
Date: Wed, 14 Jan 2009 09:39:18 -0800

On Wed, 14 Jan 2009 12:43:47 +0100 Ingo Molnar <[email-masked]> wrote:

> 
> * Andrew Morton <[email-masked]> wrote:
> 
> > On Fri, 9 Jan 2009 17:19:17 +0100 Joerg Roedel <[email-masked]> wrote:
> > 
> > > +struct hash_bucket {
> > > +	struct list_head list;
> > > +	spinlock_t lock;
> > > +} ____cacheline_aligned;
> > 
> > __cacheline_aligned_in_smp.
> > 
> > This all looks like an exotically large amount of code for a debug 
> > thingy?
> 
> this code checks the DMA usage of ~1 million lines of kernel code - all 
> the DMA using drivers. I think Joerg's feature is hugely relevant as DMA 
> scribbles are one of the hardest to debug kernel bugs: they can end up in 
> permanent data corruption or other hard to find bugs. In fact i think his 
> patchset is rather simple and even having 10 times as much debug code 
> would pay for its existence in the long run.
> 

Have we previously found bugs by other means which this facility would
have detected?  I don't recall any...